game={
	debug: false,
	version: 1.3,
	state:"loading",
	imageLoaded:false,
	loadingComplete:function(){
		for(s in game.sounds){
			if(!game.soundLoaded[s]){
				return false;
			}
		}
		if(!game.soundLoaded["title"]){
			return false;
		}
		if(!game.imageLoaded){
			return false;
		}
		
		return true;
	},
	time: 1,
	volume: .2,
	musicVolume: .3,
	paused: true,
	cleanUp:function(){
		//todo:
		//	-loop through all levels
		//	-loop through all tiles
		//		-null monster's tile, monster
		//		-null item's tile, item
	},
	powerCurve:function(level){
		return Math.pow(level-1,2);
	},
	shallowPowerCurve:function(level){
		return game.powerCurve(level)*.03+1;
	},
	init: function(){
		game.potionMenuOpen = false;

		game.time = 60*5.9;
		game.paused = false;
		
		game.faneLocked = true;

		$("#console").html("");
		
		//title
		//running 
		//dead
		
		game.state = "running";
		game.forgivyTime = false;
		
		game.log("Welcome to the Golden Krone Hotel!");
		
		game.setVolume(game.volume);
	},
	currentMusic: null,
	sounds:{
		explosion:	"sounds/Explosion71.wav",
		levelUp:	"sounds/levelup.wav",
		hit1:		"sounds/hit1.wav",
		hit2:		"sounds/hit2.wav",
		hit3:		"sounds/hit3.wav",
		hit4:		"sounds/hit4.wav",
		hit5:		"sounds/hit5.wav",
		shock:		"sounds/shock-shorter.wav",
		heal:		"sounds/heal-louder.wav",
		ice:		"sounds/ice.wav",
		firestorm:	"sounds/firestorm-quiter.wav",
		gold:		"sounds/gold.wav",
		silver:		"sounds/silver.wav",
		blast:		"sounds/blast.wav",
		death:		"sounds/death.wav",
		glow:		"sounds/glow.wav",
		vitalise:	"sounds/vitalise.wav",
		detect:		"sounds/detect.wav"
	},
	music:{
		title:		"sounds/AmazingPlan.mp3",
		dungeon1:	"sounds/NightofChaos.mp3",
		dungeon2:	"sounds/SpiderEyes.mp3",
		dungeon3:	"sounds/ItIsLost.mp3",
		dungeon4:	"sounds/UnseenHorrors.mp3",
		library:	"sounds/Relent.mp3",
		fane:		"sounds/FinalCount.mp3"
	},
	startLoadingSounds:function(){
		for(s in game.sounds){
			game.soundLoaded[s]=false;
		}
		for(m in game.music){
			game.soundLoaded[m]=false;
		}
		game.loadSound();
	},
	loadSound:function(){
		for(s in game.sounds){
			if(!game.soundLoaded[s]){
				game.sounds[s] = new Audio(game.sounds[s]);
				game.sounds[s].onloadeddata=(function(s){
					return function(){
						game.soundLoaded[s]=true;
						game.loadSound();
					};
				})(s);
				return;
			}	
		}
		for(m in game.music){
			if(!game.soundLoaded[m]){
				game.music[m] = new Audio(game.music[m]);
				game.music[m].onloadeddata=(function(m){
					return function(){
						game.soundLoaded[m]=true;
						game.loadSound();
					};
				})(m);
				return;
			}
		}
	},
	soundLoaded:{},
	setMusicVolume:function(newVolume){
		game.musicVolume=newVolume;
		if(game.currentMusic){
			game.music[game.currentMusic].volume = game.musicVolume;
		}
	},
	setVolume:function(newVolume){
		game.volume=newVolume;
	},
	playSound:function(soundName){
		if(game.soundLoaded[soundName]){
			game.sounds[soundName].volume = game.volume;
			game.sounds[soundName].pause();
			game.sounds[soundName].currentTime = 0;
			game.sounds[soundName].play();
		}else{
			setTimeout(function(){game.playSound(soundName)},100);
		}
	},
	playMusic:function(musicName){
		if(game.soundLoaded[musicName]){
			game.music[musicName].volume = game.musicVolume;
			game.music[musicName].pause();
			game.music[musicName].currentTime = 0;
			game.music[musicName].loop = true;
			game.music[musicName].play();

			game.currentMusic = musicName;
		}else{
			//setTimeout(function(){game.playMusic(musicName)},100);
		}
	},
	replacementMusic: null,
	replaceMusic:function(replacementMusic){
		if(game.currentMusic){
			game.replacementMusic = replacementMusic;
			var musicName = game.currentMusic;
			if(game.soundLoaded[musicName]){
				$(game.music[musicName]).animate({volume: 0}, 1500, 'swing',function(){
					game.currentMusic = null;
					if(game.replacementMusic){
						game.playMusic(game.replacementMusic);
					}
				});
			}
		}else if(replacementMusic){
			game.playMusic(replacementMusic);
		}
	},
	updateScores:function(){
		var scores = game.getScores();
		var scoreHtml = "";

		if(scores.length>0){
			var newest = scores.concat().sort(function(a,b){
				return new Date(b.actualDate)-new Date(a.actualDate);
			})[0].actualDate;

			scoreHtml+='<table>';
			scoreHtml+='<tr><th colspan="6">Guestbook</th></tr>';
			scoreHtml+='<tr><th>Name</th><th>Arrival</th><th>Duration</th><th>Floor</th><th>Balance</th><th></th></tr>';
			for(var i=0;i<Math.min(5,scores.length);i++){
				var tweet = "";
				if(scores[i].actualDate == newest && scores[i]['gold']>0){
					if(!isNaN(scores[i]['floor'])){
						var fullFloor = "on Floor "+scores[i]['floor'];
					}else{
						var fullFloor = "in the "+scores[i]['floor'];
					}
					if(scores[i].won){
						var tweetMessage = "I subdued Fane, the Exiled Vampire Prince, and escaped the Golden Krone Hotel with "+game.moneyIt(scores[i]['gold'])+"!"
					}else{
						var tweetMessage = "I died "+fullFloor+" of the Golden Krone Hotel. I was carrying "+game.moneyIt(scores[i]['gold'])+".";
					}
					var tweetQuery = 'text='+encodeURIComponent(tweetMessage) + '&url='+encodeURIComponent("http://humbit.com/gkh/");
					tweet = '<a href="https://twitter.com/intent/tweet?'+tweetQuery+'"><img src="img/tweet.png"></a>';
				}

				scoreHtml+='<tr>'+
					'<td>S. Arobase</td>'+
					'<td>'+scores[i]['date']+'</td>'+
					'<td>'+scores[i]['days']+(scores[i]['days']> 1 ? " days":" day")+'</td>'+
					'<td>'+scores[i]['floor']+'</td>'+
					'<td>'+game.moneyIt(scores[i]['gold'])+'</td>'+
					'<td>'+tweet+'</td>';
			}
			scoreHtml+='</table>'
		}
		
		$("#guestbook").html(scoreHtml);
	},
	moneyIt: function(amount){
		var amount = amount + "";
		if(amount.length>3){
			return "$"+amount.substring(0,amount.length-3)+","+amount.substring(amount.length-3);
		}else{
			return "$"+amount;
		}
	},
	addScore: function(date, actualDate, days, floor, gold, won){
		var scores = [];
		var storageName = "gkh."+game.version+".scores";
		if(game.localStoragedSupported()){
			if(localStorage[storageName] && localStorage[storageName]!==	undefined){
				scores = JSON.parse(localStorage[storageName]);
			}
			
			scores.push({
				date: date,
				actualDate: actualDate,
				days: days,
				floor: floor,
				gold: gold,
				won: won
			});
			
			localStorage[storageName] = JSON.stringify(scores);
		}
	},
	getScores: function(){
		var scores = [];
		var storageName = "gkh."+game.version+".scores";

		if(game.localStoragedSupported() && localStorage[storageName]){
			scores = JSON.parse(localStorage[storageName]);

			return scores.sort(function(a,b){
				return b.gold-a.gold;
			});
		}else{
			return [];
		}
	},
	localStoragedSupported: function() {
		try {
			return 'localStorage' in window && window['localStorage'] !== null;
		} catch (e) {
			return false;
		}
	},
	fullVisibilty: false,
	getTimeOfDay: function(){
		return game.time % (60*24);
	},
	isNight: function(){
		var hour = game.getTimeOfDay()/60;
		if(hour < 6 || hour >18){
			return true;
		}else{
			return false;
		}
	},
	getDay:function(){
		return Math.ceil(game.time / (60*24));
	},
	capitalize:function(s){
		return s[0].toUpperCase()+s.slice(1);
	},
	getTimeDescription:function(){
		var t = game.getTimeOfDay();
		
		var hour = Math.floor((t/60))%12;
		if(hour==0){
			hour+=12;
		}
		
		if(hour<10){
			hour = "&nbsp;"+hour;
		}
		
		var minute = Math.floor(t % 60);
		if(minute<10){
			minute = "0"+minute;
		}
		
		var description = "";
		description+=hour+":"+minute;
		if(t>=60*12){
			description+="pm";
		}else{
			description+="am";
		}
		
		return description;
	},
	getShortTimeDescription:function(){
		var t = game.getTimeOfDay();
		
		var hour = Math.floor((t/60))%12;
		if(hour==0){
			hour+=12;
		}
		
		if(hour<10){
			hour = "&nbsp;"+hour;
		}
		
		var minute = Math.floor(t % 60);
		if(minute<10){
			minute = "0"+minute;
		}
		
		var description = "";
		description+=hour+":"+minute;
		
		return description;
	},
	//to be called after a player performs an action
	tick:function(timeJump,skipDraw){
		//slowing down time here
		game.time+=timeJump/2.0;
		
		var monsters = map.getCurrentLevel().monsters;
		for(var i=monsters.length-1;i>=0;i--){
			if(monsters[i]!==null){
				monsters[i].performActions(timeJump);
			}
			if(monsters[i]!==null){
				monsters[i].update(timeJump);
			}
		}
		
		player.tick(timeJump);
		
		//remove blood
		for(var i=0;i<map.getCurrentLevel().levelSize;i++){
			for(var j=0;j<map.getCurrentLevel().levelSize;j++){
				var tile = map.getTile(i,j);
				if(tile.item!=null && tile.item.type =="blood"){
					tile.item.removeCounter-=timeJump/10.0;
					if(tile.item.removeCounter<=0){
						tile.item = null;
					}
				}
			}
		}
	
		if(player.celestial <=0 && player.unholy <= 0){
			lighting.initLightRound();
			lighting.calculateSunlight();
			lighting.checkBurning();
			lighting.calculateDynamicLighting();
		}else{
			var displayTiles = map.getDisplayTiles();
			for(var i=0;i<displayTiles.length;i++){
				if(player.celestial>0){
					displayTiles[i].light = 20;
				}

				if(player.unholy>0){
					displayTiles[i].light = 0;
					var playerSurroundingTiles = player.getTile().getAllNeighbors();
					playerSurroundingTiles.push(player.getTile());
					for(var j=0;j<playerSurroundingTiles.length;j++){
						if(playerSurroundingTiles[j].light < player.visibilityThreshold){
							playerSurroundingTiles[j].light=player.visibilityThreshold;
						}
					}
				}
			}
			lighting.checkBurning();
		}

		
		if(!skipDraw){
			drawCanvas();
		}
	},
	log:function(message){
		$("#console").append(
			'<table><tr><td style="color:#aaa;padding-right:10px;vertical-align:top;">'+game.getShortTimeDescription()+'</td><td>'+message+'</td></tr></table>'
		);
		$("#console").scrollTop($("#console")[0].scrollHeight);
	},
	chat:function(name, message, type){
		if(type=="human"){
			var nameColor = "rgb(255,221,17)";
		}else{
			var nameColor = "rgb(255,68,51)";
		}
		$("#console").append('<span style="font-weight:bold;color:'+nameColor+';">'+name+'</span> '+message+'<br>');
		$("#console").scrollTop($("#console")[0].scrollHeight);
	},
	showMenu:function(content, isPotionMenu){
		$("#modal").show();
		$("#modal").html(content);
		game.menuOpen = true;

		if(isPotionMenu){
			game.potionMenuOpen = true;
		}else{
			game.potionMenuOpen = false;
		}
	},
	closeMenu:function(){
		game.menuOpen = false;
		game.potionMenuOpen = false;
		$("#modal").hide();
	},
	menuOpen: false,
	describe: function(i,j){
		var html = "";
		
		var tile = map.getTile(i,j);
		
		if(tile.light>=player.visibilityThreshold && tile.playerVisible){
			if(tile.i==player.x && tile.j==player.y){
				html+='<h1 class="description">Sorina Arobase</h1>';
				html+='<p>That\'s you!</p>';
			}
		
			html+='<h1 class="description">'+tile.getName()+'</h1>';
			html+='<p>'+tile.getDescription()+'</p>';
			
			if(tile.monster != null){
				if(tile.monster.givenName != "" && tile.monster.name != "Fane"){
					html+='<h1 class="description">'+tile.monster.givenName + ' ('+tile.monster.name+')</h1>';
				}else{
					html+='<h1 class="description">'+tile.monster.name+'</h1>';
				}
				
				html+='<p>'+tile.monster.getDescription()+'</p>';
			}
			
			if(tile.torch == 1){
				html+='<h1 class="description">Unlit torch</h1>';
				html+='<p>You could light it yourself if you had some oil.</p>';
			}else if(tile.torch == 2){
				html+='<h1 class="description">Burning torch</h1>';
				html+='<p>You could extinguish that if you wanted to.</p>';
			}
			
			if(tile.item != null){
				html+='<h1 class="description">'+tile.item.getName()+'</h1>';
				html+='<p>'+tile.item.getDescription()+'</p>';
			}
		}else{
			html+='<h1 class="description">You can\'t make that out right now. Maybe if you get closer...</h1>';
		}	
		
		
		game.showMenu(html);
	},
	//http://stackoverflow.com/questions/2450954/how-to-randomize-shuffle-a-javascript-array
	shuffle:function shuffle(array) {
	  var currentIndex = array.length, temporaryValue, randomIndex ;

	  // While there remain elements to shuffle...
	  while (0 !== currentIndex) {

	    // Pick a remaining element...
	    randomIndex = Math.floor(Math.random() * currentIndex);
	    currentIndex -= 1;

	    // And swap it with the current element.
	    temporaryValue = array[currentIndex];
	    array[currentIndex] = array[randomIndex];
	    array[randomIndex] = temporaryValue;
	  }

	  return array;
	},
	openPotionMenu:function(){
		var html = "";
		
		html+='<h1>Potions</h1>';
		
		html+='<table style="border-spacing: 0px">';
		
		var potionArray = player.getShuffledPotionArray();
		
		var hasPotions = false;
		
		var apparentIndex = 0;
		for(var i=0;i<potionArray.length;i++){
			var q = potionArray[i][1];
			if(q>0){
				html+='<tr><td style="cursor:pointer" class="potion-list-name" data-potion="'+potionArray[i][0]+'">'+potions.getPotionName(potionArray[i][0])+'</td><td>'+q+'</td><td>'+
					'<button class="ui-button potion-button" data-potion="'+potionArray[i][0]+'">['+String.fromCharCode(apparentIndex+97)+'] Quaff</button>'+
				'</td></tr>';
				hasPotions = true;
				apparentIndex++;
			}
		}
		
		html+='</table>';
		
		if(!hasPotions){
			html+='<div>No potions</div>';
		}else{
			html+='<div id="potion-description" style="padding:30px 20px 10px 20px;font-style:italic;"></div>';
		}
		
		game.showMenu(html, true);
	},
	describePotion:function(potionName){
		$("#potion-description").html(potions.getDescription(potionName));
	},
	addButtons:function(){
		var buttonHtml="";
		var playerTile = player.getTile();
		
		buttonHtml +='<div id="potion-button" class="ui-button">[P]otions</div>';
		buttonHtml +='<div id="ingame-help-button" class="ui-button">[?] Help</div>';
		buttonHtml +='<div id="ingame-options-button" class="ui-button">[O]ptions</div>';
		
		if(playerTile.type=="staircase"){
			buttonHtml +='<div id="staircase-button" class="ui-button context-button">[T]ake Stairs</div>';
		}

		if(playerTile.torch==1){
			buttonHtml +='<div id="e-button" class="ui-button context-button">[E]nkindle</div>';
		}else if(playerTile.torch==2){
			buttonHtml +='<div id="e-button" class="ui-button context-button">[E]xtinguish</div>';
		}
		
		if(playerTile.item!=null && playerTile.item.type=="book"){
			
			var buttonText;
			if(playerTile.item.bookType == 0){
				buttonHtml +='<div id="read-button" class="ui-button context-button">[R]ead Chronicle</div>';
			}else if(playerTile.item.bookType == 1){
				buttonHtml +='<div id="read-button" class="ui-button context-button">[R]ead Manual</div>';	
			}else if(playerTile.item.bookType == 2){
				buttonHtml +='<div id="read-button" class="ui-button context-button">[R]ead Grimoire</div>';	
			}else if(playerTile.item.bookType == 3){
				buttonHtml +='<div id="read-button" class="ui-button context-button">[R]ead Primer</div>';	
			}
		}
		
		if(game.forgivyTime){
			buttonHtml +='<div id="forgive-button" class="ui-button context-button">[F]orgive Fane</div>';
		}
		
		

		$("#button-container").append(buttonHtml);
	}
}