player={
	x:2,
	y:2,
	hungerDescriptions:["starving","hungry","","satiated","food coma"],
	init:function(){
		player.firstName = "Sorina";
		player.lastName = "Arobase";
	
		player.maxHealth = 40;
		player.health = player.maxHealth;
		player.hunger = 65;
		player.vampirism = 0;
		player.strength = 6;
		player.dexterity = 6;
		player.intelligence = 6;
		player.strengthBoost = 0;
		player.dexterityBoost = 0;
		player.intelligenceBoost = 0;
		player.attack = 0;
		player.defense = 0;
		player.gold = 0;
		player.sword = 1;
		player.shield = 1;
		player.armor = 1;

		player.glow = 0;
		player.glowDuration = 0;

		player.unholy = 0;
		player.celestial = 0;

		player.detect = 0;
		
		player.level = 1;
		player.statPoints = 0;
		
		player.xp=0;
		
		player.waiting = false;
		
		player.slowCounter = 0;
		
		player.potions = {};


		if(game.debug){
			player.level = 11;
			player.maxHealth = 202;

			player.health = 202;

			player.shield = 9;
			player.armor = 9;
			player.sword = 9;

			player.dexterity = 12;
			player.strength = 12;
			player.intelligence = 12;

			//player.xp = 2900;

			//player.vampirism = 100;


		}


		
		for(var i=0;i<potions.potionObjects.length;i++){
			player.potions[potions.potionObjects[i].name]=0;
		}
		
		
		player.addPotion("Soul Elixir");
		player.addPotion("Soul Elixir");
		player.addPotion("Oil");
		player.addPotion("Oil");
		player.addPotion("Oil");
		player.addPotion("Ale");

		player.prevIsVampire = false;
		player.updateStats();
	},
	gameOver:function(won){
		//list credits here:
		
		game.log('==========================');
		game.log('Press [Y] to start a new game.');
		if(won){
			game.log('==========================');
			game.log('A game by Jeremiah Reid.');
			game.log('Special thanks to: Charles Scheffer, Nicole Reid, Joshua Martin, Elliot Bonneville');
			game.log('Music by Kevin MacLeod (<a style="color:white !important" target="_blank" href="http://incompetech.com">incompetech.com</a>: Amazing Plan, Night of Chaos, Echoes of Time, Unseen Horrors, Controlled Chaos, Spider Eyes, Relent, and Final Count.)');
		}
		
		romMon = ['gerar','faurar','martisor','prier','florar','ciresar','cuptor','gustar','rapciune','brumarel','brumar','undrea'];
		

		var floorDescription = (map.levelIndex+1);
		if(map.levelIndex>map.FANE_LEVEL){
			floorDescription = map.branchNames[map.levelIndex];
		}

		var d = new Date();
		game.addScore(
			romMon[d.getMonth()]+" "+d.getDate(),
			new Date(),
			game.getDay(),
			floorDescription,
			player.gold,
			won
		);
		
		game.updateScores();
	},
	addPotion:function(potionName){
		player.potions[potionName]++;
	},
	quaffByCode:function(keyCode){
		var pi = keyCode - 65;
		var potionArray = player.getShuffledPotionArray();

		var apparentIndex = 0;
		for(var i=0;i<potionArray.length;i++){
			if(potionArray[i][1]>0){
				if(apparentIndex==pi){
					player.quaffPotion(potionArray[i][0]);
					return;
				}
				apparentIndex++;
			}
		}
	},
	quaffPotion:function(potionName){
		var potionObject = potions.getPotion(potionName);
		var identified = potions.identified(potionName);
		if(player.potions[potionName]>0){
			game.log("You quaff the "+potions.getPotionName(potionName)+".");
			player.potions[potionName]--;
			potionObject.quaff();
			potionObject.identify-=2;
			
			if(potions.identified(potionName) && !identified){
				game.log("It was a vial of "+potions.getPotionName(potionName)+".");
			}
		}
		game.tick(50.0/player.getTotalDexterity());
	},
	getShuffledPotionArray:function(){
		var arr = [];
		for(var p in player.potions){
			arr.push([p,player.potions[p]]);
		}
		
		//NO LONGER SHUFFLING ACTUALLY LOL
		
		return arr;
	},
	drawUI:function(){
		$("#stat-health").html(player.getHealthDescription());
		$("#stat-hunger").html(player.getHungerDescription());
		$("#stat-vampirism").html(player.getVampirismDescription());
		$("#stat-strength").html(player.getStrengthDescription());
		$("#stat-dexterity").html(player.getDexterityDescription());
		$("#stat-intelligence").html(player.getIntelligenceDescription());
		$("#stat-attack").html(player.attack);
		$("#stat-defense").html(player.defense);
		
		$("#stat-level").html(player.level);
		
		$("#light-icon").attr("src",'img/'+lighting.lightIcon+'.png');
		

		var floorAbbrev = "F"+(map.levelIndex+1);
		if(map.levelIndex>map.FANE_LEVEL){
			floorAbbrev = map.branchNames[map.levelIndex].substr(0,5);
		}

		$("#stat-list").html(
			game.getTimeDescription()+"&nbsp;&nbsp;&nbsp;&nbsp;"+
			"Day "+game.getDay()+"&nbsp;&nbsp;&nbsp;&nbsp;"+
			"$"+player.gold+"&nbsp;&nbsp;&nbsp;&nbsp;"+
			floorAbbrev
		);
		
		if(player.isVampire()){
			$("#stat-sword").html("-");
			$("#stat-shield").html("-");
		}else{
			$("#stat-sword").html("+"+player.sword);
			$("#stat-shield").html("+"+player.shield);
		}
		
		$("#stat-armor").html("+"+player.armor);
		$("#stat-time").html(game.getTimeDescription());
		
		
		if(player.statPoints>0){
			$(".stat-button").show();
		}else{
			$(".stat-button").hide();
		}
		
		magic.draw();
		game.addButtons();
	},
	updateStats:function(){
		if(game.state == "running"){
			while(player.xp >= game.powerCurve(player.level+1)*25){
				player.level++;
				player.statPoints++;
				game.log('<span style="color:#22cc11;">You are now level '+player.level+'! You can upgrade a stat (press [S],[D], or [I]).</span>');
				game.playSound("levelUp");
			}
			
			player.maxHealth = game.powerCurve(player.level)*2+40;
		
			if(player.isVampire()){
				player.strengthMultiplier=2;
				player.dexterityMultiplier=1.5;
				player.intelligenceMultiplier=.5;
			}else{
				player.strengthMultiplier=1;
				player.dexterityMultiplier=1;
				player.intelligenceMultiplier=1;
			}
			
			player.attack = Math.ceil((player.getTotalStrength()*1.333+player.getTotalSword())/2.0)+1;
			player.defense = player.armor+player.getTotalShield()+Math.ceil(player.getTotalDexterity()/4.0);
		}
	},
	increaseStat:function(stat){
		if(player.statPoints>0){
			player[stat]++;
			player.statPoints--;
		}
		
		player.updateStats();
	},
	tick:function(timeJump){
		//console.log(player.xp);
		
		player.strengthBoost = Math.max(0,player.strengthBoost-timeJump/60.0);
		player.dexterityBoost = Math.max(0,player.dexterityBoost-timeJump/60.0);
		player.intelligenceBoost = Math.max(0,player.intelligenceBoost-timeJump/60.0);

		if(player.glowDuration > 0 ){
			player.glowDuration -= timeJump;

			if(player.glowDuration <= 0){
				game.log("Your magical glow is extinguished.");
				player.glow = 0;
			}
		}

		if(player.detect > 0){
			player.detect -= timeJump;

			if(player.detect <=0){
				game.log("You no longer sense the presence of nearby creatures.");
				player.detect = 0;
			}
		}

		if(player.celestial > 0){
			player.celestial --;
		}

		if(player.unholy > 0){
			player.unholy --;
		}
		
		if(player.hunger<=0){
			player.die("You die of starvation.");
		}else if(player.health <= 0){
			player.die();
			player.bleed();
		}else{
			player.vampirism = Math.min(100,player.vampirism+timeJump/80.0);
		
			if(player.prevIsVampire != player.isVampire()){
				player.prevIsVampire = player.isVampire();
				if(player.isVampire()){
					game.log("You start to feel a nagging thirst.");
				}else{
					game.log("You feel relieved. You transform back into a Human!");
				}
			}
		
			if(player.isVampire()){
				player.visibilityThreshold = -1;
				player.lightingMultiplier = 1;

				player.health=Math.max(0,player.health-timeJump/120);
			}else{
				player.hunger-=timeJump/100.0;
				
				if(player.hunger<=2){
					game.log('<span style="color:rgba(255,68,51,1);">EAT SOMETHING!!!</span>');
				}
				
				player.health=Math.min(player.maxHealth,player.health+player.maxHealth*.01*timeJump/10);
				player.visibilityThreshold = .4;
				player.lightingMultiplier = 1;
			}
			
			player.slowCounter = Math.max(0,player.slowCounter - timeJump/40.0);
			
			player.updateStats();
		}
	},
	die:function(explanation){
		if(!explanation){
			explanation = "You die.";
		}
		game.log('<span style="font-weight: bold;color:red">'+explanation+'</span>');
		game.state = "dead";
		
		game.playSound("death");
		
		game.closeMenu();
		
		player.gameOver(false);
	},
	checkHp: function(){
		if(player.health <= 0){
			player.die();
		}
	},
	bleed:function(){
		var neighbors = player.getTile().getAllNeighbors();
		for(var i=0;i<neighbors.length;i++){
			if(Math.random()<.5 && neighbors[i].type=="floor" && neighbors[i].item==null && neighbors[i].torch == 0 && !neighbors[i].equals(player.getTile())){
				var blood = new Blood(neighbors[i]);
				neighbors[i].item=blood;
			}
		}
	},
	getHealthDescription: function(){
		if(player.health <= player.maxHealth/4.0){
			var description = ' <span style="color:rgba(255,68,51,1);">'+Math.max(0,Math.ceil(player.health))+'</span>'+" / " +player.maxHealth;
		}else{
			var description = ' <span style="">'+Math.max(0,Math.ceil(player.health))+'</span>'+" / " +player.maxHealth;
		}
		return description;
	},
	getStrengthDescription:function(){
		var description = player.getTotalStrength();
		if(player.getTotalStrength() > player.strength){
			description += ' <span style="color:#22cc11;">(+'+(player.getTotalStrength() - player.strength) +')</span>';
		}else if(player.getTotalStrength() < player.strength){
			description += ' <span style="color:rgba(255,68,51,1);">('+(player.getTotalStrength() - player.strength)+')</span>';
		}
		return description;
	},
	getDexterityDescription:function(){
		var description = player.getTotalDexterity();
		if(player.getTotalDexterity() > player.dexterity){
			description += ' <span style="color:#22cc11;">(+'+(player.getTotalDexterity() - player.dexterity) +')</span>';
		}else if(player.getTotalDexterity() < player.dexterity){
			description += ' <span style="color:rgba(255,68,51,1);">('+(player.getTotalDexterity() - player.dexterity)+')</span>';
		}
		return description;
	},
	getIntelligenceDescription:function(){
		var description = player.getTotalIntelligence();
		if(player.getTotalIntelligence() > player.intelligence){
			description += ' <span style="color:#22cc11;">(+'+(player.getTotalIntelligence() - player.intelligence) +')</span>';
		}else if(player.getTotalIntelligence() < player.intelligence){
			description += ' <span style="color:rgba(255,68,51,1);">('+(player.getTotalIntelligence() - player.intelligence)+')</span>';
		}
		return description;
	},
	getTotalStrength:function(){
		return Math.ceil(player.strength*player.strengthMultiplier+player.strengthBoost);
	},
	getTotalDexterity:function(){
		return Math.ceil(player.dexterity*player.dexterityMultiplier-player.slowCounter+player.dexterityBoost);
	},
	getTotalIntelligence:function(){
		return Math.ceil(player.intelligence*player.intelligenceMultiplier+player.intelligenceBoost);
	},
	getTotalSword:function(){
		if(player.isVampire()){
			return 0;
		}else{
			return player.sword;
		}
	},
	getTotalShield:function(){
		if(player.isVampire()){
			return 0;
		}else{
			return player.shield;
		}
	},
	getHungerDescription:function(){
		if(player.isVampire()){
			return "-";
		}
	
		var hungerIndex = Math.max(0,Math.min(4,Math.floor(player.hunger/20)));
		if(hungerIndex==0){
			return '<span style="color:rgba(255,68,51,1);">'+player.hungerDescriptions[hungerIndex]+'</span>';
		}else if(hungerIndex==1){
			return '<span style="color:rgba(255,221,17,1);">'+player.hungerDescriptions[hungerIndex]+'</span>';
		}else{
			return player.hungerDescriptions[hungerIndex];
		}
		
	},
	getVampirismDescription:function(){
		if(!player.isVampire()){
			return '<span style="color:rgba(255,255,255,'+(.75*(50-player.vampirism)/50+.25)+')">human</span>';
		}else{
			return '<span style="color:rgba(255,68,51,'+(.75*(player.vampirism-50)/50+.25)+')">vampire</span>';
		}
	},
	isVampire:function(){
		return player.vampirism> 50;
	},
	visibilityThreshold: .4,
	lightingMultiplier: 1,
	up:function(){
		if(magic.state == "waiting"){
			magic.finishCast(1, player.x,player.y, true);
		}else{
			player.tryMove(0,-1);
		}
	},
	down:function(){
		if(magic.state == "waiting"){
			magic.finishCast(3, player.x,player.y,true);
		}else{
			player.tryMove(0,1);
		}
	},
	left:function(){
		if(magic.state == "waiting"){
			magic.finishCast(2, player.x,player.y,true);
		}else{
			player.tryMove(-1,0);
		}
	},
	right:function(){
		if(magic.state == "waiting"){
			magic.finishCast(0, player.x,player.y,true);
		}else{
			player.tryMove(1,0);
		}
	},
	tryMove:function(x,y){
		if(magic.forgetState !="idle"){
			magic.forgetState="idle";
			game.log("Nevermind.");
		}
		
		var newX = player.x+x;
		var newY = player.y+y;
		
		var newTile = map.getTile(newX,newY);
		
		if(newTile.monster!=null){
			if(newTile.monster.isFriendly()){
				newTile.monster.interact();
				game.tick(50.0/player.getTotalDexterity());
			}else{
				//bump attack
			
				//take away monster HP
				game.playSound("hit"+map.randRange(1,5));
				
				var hitAmount = player.attack*(Math.random()+.5);
				if(Math.random()<.05){
					hitAmount *=2.0;
				}

				newTile.monster.hit(hitAmount);
			
				game.tick(50.0/player.getTotalDexterity());
			}
		}else if(newTile.isPassable() || newTile.type=="door"){
			player.x = newX;
			player.y = newY;
			
			newTile.stepOn();
			
			//elapse some time based on speed
			
			//pass in new time
			game.tick(50.0/player.getTotalDexterity());
		}
	},
	hit:function(attack, source){
		var hpLoss = Math.floor(Math.max(0,attack - player.defense*Math.random()));
		player.takeDamage(hpLoss);
		
		game.log(game.capitalize(source)+' deals <span style="color:rgba(255,68,51,1);">'+hpLoss+'</span> damage to you!');
		
		game.playSound("hit"+map.randRange(1,5));
	},
	takeDamage:function(hpLoss){
		this.health = this.health-hpLoss;
	},
	getTile:function(){
		return map.getTile(this.x,this.y);
	},
	wait:function(skipDraw){
		game.tick(50.0/player.getTotalDexterity(),skipDraw);
	},
	waitTimes:function(times){
		player.waiting = true;
		if(player.health<player.maxHealth && !player.isVampire()){
			var hurt = true;
		}else{
			var hurt = false;
		}
		
		for(var i=0;i<times-1;i++){
			if(game.state !=="running"){
				game.tick(0);
				return;
			}
		
			var displayTiles = map.getDisplayTiles();
			for(var j=0;j<displayTiles.length;j++){
				var tile = displayTiles[j];
				
				if(tile.monster!= null && !tile.monster.isFriendly() && tile.monster.type!="obstacle" && tile.light >=player.visibilityThreshold && player.los(tile.i,tile.j,player.x,player.y)){
					player.waiting = false;
					game.log("There is an enemy nearby! You stop resting.");
					break;
				}
			}
			
			if(player.hunger<20 && !player.isVampire()){
				player.waiting = false;
				game.log("You're too hungry to rest.");
			}else if(hurt && player.health==player.maxHealth){
				game.log("All healed up.");
				player.waiting = false;
			}else if(player.isVampire() && player.health <= player.maxHealth/4.0){
				game.log("You can't rest. You need to feed!");
				player.waiting = false;
			}
			
			if(!player.waiting){
				break;
			}
			
			player.wait(true);
		}

		if(player.waiting){
			player.waiting=false;
			game.log("You rest for a while.");
		}
		game.tick(0);
	},
	draw:function(){
		ctx.globalAlpha = 1;
		if(game.state=="dead"){
			ssl = ssLocation(36);
		}else if(player.isVampire()){
			ssl = ssLocation(3);
		}else{
			ssl = ssLocation(2);
		}
		ctx.drawImage(ss,ssl[0],ssl[1],16,16,playerOffset*tileSize,playerOffset*tileSize,tileSize,tileSize);
		
		if(!player.isVampire() && game.state!="dead"){
			var shieldSsl = ssLocation(128+player.shield-1);
			ctx.drawImage(ss,shieldSsl[0],shieldSsl[1],16,16,playerOffset*tileSize+5*tileScaling,playerOffset*tileSize,tileSize,tileSize);
		}
		
		if(player.health<player.maxHealth && player.health > 0){
			ctx.fillStyle = "rgba(0,0,0,.8)";
			ctx.fillRect(playerOffset*tileSize+tileScaling*1,playerOffset*tileSize+tileScaling*13,tileScaling*14,tileScaling*3);
			
			ctx.fillStyle = "rgb(255,68,51)";
			ctx.fillRect(playerOffset*tileSize+tileScaling*2,playerOffset*tileSize+tileScaling*14,tileScaling*12,tileScaling*1);
			
			ctx.fillStyle = "#22cc11";
			ctx.fillRect(playerOffset*tileSize+tileScaling*2,playerOffset*tileSize+tileScaling*14,tileScaling*12*Math.max(0,player.health/player.maxHealth),tileScaling*1);
		}
	},
	fov:function(){
		var displayTiles = map.getDisplayTiles();
		for(var i=0;i<displayTiles.length;i++){
			var tile = displayTiles[i];
			if(player.los(tile.i,tile.j,player.x,player.y)){
				tile.playerVisible = true;
				tile.explored = true;
			}else{
				tile.playerVisible = false;
			}
		}
	},
	los:function(i1,j1,i2,j2){
		var angle,x,y,indexX,indexY;
		
		if(i1==i2 && j1==j2){
			return true;
		}
		
		x=i2;
		y=j2;
		angle = Math.atan2(j1-j2,i1-i2);

		for(var i=0;i<1000;i++){
			x += Math.cos(angle)*.1;
			y += Math.sin(angle)*.1;
						
			indexX = Math.floor(x+.5);
			indexY = Math.floor(y+.5);
			
			if(indexX==i1 && indexY==j1){
				return true;
			}
			
			if(map.getTile(indexX,indexY).opaque){
				return false;
			}
		}
		return true;
	},
	takeStairs:function(){
		var playerTile = player.getTile();
		
		var newIndex, newStairs;
		
		if(playerTile.type=="staircase"){
			if(playerTile.branch){
				if(playerTile.direction == "up"){
					newIndex = map.levelIndex-(1+map.numBranches);
					var stairs = map.levels[newIndex].downstairs;
					newStairs = stairs[stairs.length-1];
				}else{
					newIndex = map.levelIndex+(1+map.numBranches);
					var stairs = map.levels[newIndex].upstairs;
					newStairs = stairs[0];
				}
			}else{
				if(playerTile.direction == "up"){
					if(map.levelIndex == map.FANE_LEVEL-1 && game.faneLocked){
						game.log("You pass through the staircase as though it were through a ghost. You're not sure what magic this is, but you certainly won't be able to ascend here.");
						return;
					}

					newIndex = map.levelIndex+1;
					newStairs = map.levels[newIndex].downstairs[playerTile.stairNumber];
				}else{
					newIndex = map.levelIndex-1;
					newStairs = map.levels[newIndex].upstairs[playerTile.stairNumber];
				}
			}
			
			var oldLoc = {
				x: player.x,
				y: player.y
			};

			player.x=newStairs.i;
			player.y=newStairs.j;
			
			var newLoc = {
				x: player.x,
				y: player.y
			};

			var oldLevel = map.levels[map.levelIndex];
			var newLevel = map.levels[newIndex];

			for(var i=-1;i<=1;i++){
				for(var j=-1;j<=1;j++){
					var oldTile = oldLevel.getTile(oldLoc.x+i,oldLoc.y+j);
					var newTile = newLevel.getTile(newLoc.x+i,newLoc.y+j);

					if(i==0 && j==0){
						if(oldTile.monster!=null){
							//sorry buddy, you can't fit
							oldLevel.destroyMonster(oldTile);
						}
					}else{
						if(oldTile.monster!=null && !oldTile.monster.isFriendly() && oldTile.monster.type!="obstacle" && newTile.isPassable() && newTile.monster == null){
							var monster = oldTile.monster;
							oldLevel.removeMonster(oldTile);
							monster.tile = newTile;
							newTile.monster = monster;
							newLevel.monsters.push(monster);
						}
					}
				}
			}


			map.levelIndex = newIndex;
			
			if(newIndex > map.FANE_LEVEL){
				game.log("Welcome to the "+map.branchNames[newIndex]+"!");
			}else{
				game.log("Welcome to Floor "+(map.levelIndex+1)+"!");
			}

			var floorMusic;
			if(newIndex == map.FANE_LEVEL){
				floorMusic = "fane";
			}else if(newIndex == map.LIBRARY_LEVEL){
				floorMusic = "library";
			}else if(newIndex == map.GARDEN_LEVEL){
				floorMusic = "dungeon2";
			}else if(newIndex == map.PHARMACOPOEIA_LEVEL){
				floorMusic = "dungeon3";
			}else if(newIndex == map.MAUSOLEUM_LEVEL){
				floorMusic = "dungeon4";
			}else{
				while(true){
					floorMusic = "dungeon"+map.randRange(1,4);	
					if(floorMusic != game.currentMusic){
						break;
					}				
				}
			}
			game.replaceMusic(floorMusic);

			game.tick(1*50.0/player.getTotalDexterity());
		}

	},
	e:function(){
		var playerTile = player.getTile();
		if(playerTile.torch==1){
			player.enkindle();
		}else if(playerTile.torch==2){
			player.extinguish();
		}
	},
	extinguish:function(){
		var tile = player.getTile();
		if(tile.torch==2){
			tile.torch=1;
			game.tick(50.0/player.getTotalDexterity());
			game.log("You extinguish the burning torch.");
			if(Math.random()<.9){
				game.log("You're able to collect some unused oil.");
				player.potions["Oil"]++;
			}else{
				game.log("There's hardly any oil left here.");
			}
		}
	},
	enkindle:function(){
		var tile = player.getTile();
		if(tile.torch==1){
			if(player.potions["Oil"]>0 && potions.identified("Oil")){
				tile.torch=2;
				player.potions["Oil"]--;
				game.tick(50.0/player.getTotalDexterity());
				game.log("You use one of your oil vials to enkindle the torch.");
			}else{
				game.log("You'll need some oil to do that. Try getting some from a burning torch.");
			}
		}
	}
}